<script lang="ts" setup>
import { Licence, Projet } from '~/models/projet';
const links = [
  {
    text: 'Accueil ',
    to: '/',
  },
  {
    text: 'Ressources',
    to: '/ressources/projets-existants',
  },
  {
    text: 'Projets Existants',
  },
];
const { getItems } = useDirectusItems();
const config = useRuntimeConfig();
const router = useRouter();
const route = useRoute();

const limit = 9;
const projets = ref();
const licences = ref<Licence[]>([]);
const selectedLicence = ref<Licence | 'all'>('all');

const count = ref(0);
const currentPage = computed({
  get: () => Number(route.query.page) || 0,
  set(page: number) {
    router.replace({ query: { ...route.query, page: page } });
  },
});
const pages = computed(() => {
  const np = Math.ceil(count.value / limit);
  return [...Array(np).keys()]
    .map((number) => number + 1)
    .map((page) => ({
      label: String(page),
      title: `Page ${page}`,
      href: `?page=${page}`,
    }));
});

const truncateString = (str: string, charNumber = 160) => {
  if (str.length > charNumber) {
    return `${str.substring(0, charNumber)}...`.replace(/<[^>]+>/gi, '');
  }
  return str;
};
const formatServicesResult = (services: Projet[]) => {
  return services.map((service) => {
    let image = service.images[0] && `${config.public.directus.url}/assets/${service.images[0].directus_files_id}`;
    let licence = licences.value.find((licence) => licence.id === service.license)?.name;
    return {
      slug: service.slug,
      name: service.name,
      description: service.description,
      competence: service.competence,
      licence,
      image,
    };
  });
};
const getLicences = async () => {
  licences.value = await getItems<Licence[]>({
    collection: 'Licences',
    params: {
      fields: ['name', 'id'],
    },
  });
};
const fetchCurrentPage = async (filter?: any) => {
  if (filter) {
    currentPage.value = 0;
  }
  const res = await getItems<any>({
    collection: 'services',
    params: {
      meta: ['total_count', 'filter_count'],
      limit: limit,
      offset: currentPage.value * limit,
      ...(filter && { filter }),
      fields: ['name', 'slug', 'description', 'competence', 'images.directus_files_id', 'license'],
    },
  });

  const services: Projet[] = res.data;
  count.value = filter ? res.meta.filter_count : res.meta.total_count;

  if (services) projets.value = formatServicesResult(services);
};
const filterServices = async (event: any) => {
  let filter;
  if (event?.target.value !== 'all') {
    const licenceId = licences.value.find((licence) => licence.name === event?.target.value)?.id;
    filter = { license: { _eq: licenceId } };
  }
  fetchCurrentPage(filter);
};
const populateParameters = () => {
  const queryPage = route.query.page ? route.query.page : 0;
  if (typeof queryPage === 'string') {
    currentPage.value = parseInt(queryPage);
  }
};
const onPageChange = (page: number) => {
  currentPage.value = page;
};
watch(currentPage, () => {
  if (currentPage.value) {
    router.push({ query: { page: currentPage.value } }).catch(() => {});
  }
  populateParameters();
  fetchCurrentPage();
});
onMounted(() => {
  getLicences();
  populateParameters();
  fetchCurrentPage();
});
</script>

<template>
  <div>
    <BlockWithLogo svg-path="/img/existing.svg" title="Projets existants">
      <template #text>
        Découvrez les projets accompagnés par l'Incubateur,<br />
        qui reposent sur des licences ouvertes.
      </template>
    </BlockWithLogo>
    <div class="fr-container">
      <DsfrBreadcrumb :links="links" />
      <div class="projets fr-pb-13w">
        <div class="filter fr-mr-4w fr-pl-3w fr-pt-3w fr-pb-3w fr-text--sm anct-bg-grey">
          <div class="fr-text--md fr-text--bold">Filtrer les projets</div>
          <div class="filter_select fr-col-11">
            <select v-model="selectedLicence" class="fr-input la-external-link-alt-solid" @input="filterServices">
              <option value="all">Tous les types de licences</option>
              <template v-for="(li, index) in licences" :key="`type--${index}`">
                <option :value="li.name" class="fr-m-2v">{{ li.name }}</option>
              </template>
            </select>
          </div>
        </div>
        <ul class="projets-list fr-grid-row fr-grid-row--gutters">
          <template v-for="(projet, index) in projets" :key="`projet--${index}`">
            <li class="fr-col-lg-4">
              <ProjetItem
                style="max-width: 350px"
                :title="projet.name"
                :img-src="projet.image"
                :license="projet.licence"
                :detail="projet.competence"
                :link="{
                  path: '/ressources/projets-existants/' + projet.slug,
                }"
              >
                <template #description>
                  <!-- eslint-disable-next-line vue/no-v-html-->
                  <p v-if="projet.description" class="fr-text--sm" v-html="truncateString(projet.description)"></p>
                </template>
              </ProjetItem>
            </li>
          </template>
        </ul>
      </div>
      <div v-if="count" class="is-flex flex-center">
        <DsfrPagination v-model:current-page="currentPage" :pages="pages" @update:current-page="onPageChange" />
      </div>
    </div>
  </div>
  <Follow />
</template>
<style lang="scss">
.filter_select {
  display: inline-block;
  position: relative;
  &::after {
    position: absolute;
    top: 0;
    right: 0;
    content: '\2304';
    font-size: 30px;
    padding-right: 2px;
  }
}
</style>
